--- linux-2.6.15.4-mips/arch/mips/vsc452/reset.c	1969-12-31 19:00:00.000000000 -0500
+++ linux/arch/mips/vsc452/reset.c	2009-08-11 21:44:22.000000000 +0530
@@ -0,0 +1,72 @@
+/*
+ * Carsten Langgaard, carstenl@mips.com
+ * Copyright (C) 1999,2000 MIPS Technologies, Inc.  All rights reserved.
+ *
+ * ########################################################################
+ *
+ *  This program is free software; you can distribute it and/or modify it
+ *  under the terms of the GNU General Public License (Version 2) as
+ *  published by the Free Software Foundation.
+ *
+ *  This program is distributed in the hope it will be useful, but WITHOUT
+ *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ *  for more details.
+ *
+ *  You should have received a copy of the GNU General Public License along
+ *  with this program; if not, write to the Free Software Foundation, Inc.,
+ *  59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
+ *
+ * ########################################################################
+ *
+ * Reset the MIPS boards.
+ *
+ */
+#include <linux/pm.h>
+
+
+#include <asm/io.h>
+#include <asm/reboot.h>
+#include <asm/addrspace.h>
+
+#define SRAM ((volatile unsigned long*)0xB0005000)
+#define POS ((volatile unsigned long*)0xB02008A8)
+#define FHR ((volatile unsigned long*)0xB02008F4) // Force Hardware Reset  
+
+#define FORCE_SYSTEM_RESET	0x0080 
+#define FORCE_CPU_RESET	0x0040
+
+static void mips_machine_restart(char *command);
+static void mips_machine_halt(void);
+
+/* On reset from kernel. We dont jump to reset vector location 0xbfc00000 , instead make the CPU to 
+   send SI_Reset using Force Hardware Reset Register , which result in  making reset vector in flash ( BEV = 1) */
+
+static void mips_machine_restart(char *command)
+{
+	//signed long val;
+	//void (*func)(void) = (void *)CKSEG1ADDR(0x1fc00000);
+		
+	/* Update SRAM for OEM_RESET_INTERNAL condition */
+	*(SRAM) = 0x51;
+	*(POS) = 0x00;
+	
+	//func();
+	
+	*(FHR)= FORCE_SYSTEM_RESET;
+}
+
+static void mips_machine_halt(void)
+{
+	*(FHR)= FORCE_SYSTEM_RESET;       
+	           
+	// void (*func)(void) = (void *)CKSEG1ADDR(0x1fc00000);
+	// func();
+}
+
+void mips_reboot_setup(void)
+{
+	_machine_restart = mips_machine_restart;
+	_machine_halt = mips_machine_halt;
+	pm_power_off = mips_machine_halt;
+}
